## dlt-viewer 2.28.0+dfsg

=== debian/changelog ===
dlt-viewer (2.28.0+dfsg-1~exp2) experimental; urgency=medium

  * Ignore a new test result, failing on big endian architectures

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Jul 2025 13:54:41 +0200

dlt-viewer (2.28.0+dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 2.28.0+dfsg
    - actually this is the same version tarball, but renaming it
      to make clear we strip files inside.
  * Update control file for new VCS location
  * Add new test
  * Add patch proposed upstream to fix a test failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Jul 2025 07:34:01 +0200

dlt-viewer (2.28.0-2) experimental; urgency=medium

  * Edit control, remove extra space
  * This version should also build fine with gcc-15 (Closes: #1096530)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Jul 2025 07:31:05 +0200

dlt-viewer (2.28.0-1) experimental; urgency=medium

  * New upstream version 2.28.0
  * Drop patches

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 28 Jul 2025 07:06:27 +0200

## dlt-viewer 2.28.1

=== CMakeLists.txt ===
# SPDX-License-Identifier: MPL-2.0
#
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author

cmake_minimum_required (VERSION 3.15)
# implicitly calls version checks
include(scripts/windows/version.cmake)
include(scripts/linux/version.cmake)

project(dlt-viewer
    VERSION ${DLT_PROJECT_VERSION_MAJOR}.${DLT_PROJECT_VERSION_MINOR}.${DLT_PROJECT_VERSION_PATCH}
    DESCRIPTION "DLT Viewer")
message(STATUS "DLT Viewer version: ${DLT_PROJECT_VERSION_MAJOR}.${DLT_PROJECT_VERSION_MINOR}.${DLT_PROJECT_VERSION_PATCH}-${DLT_VERSION_SUFFIX}")

file(WRITE "${CMAKE_BINARY_DIR}/version.txt" "${DLT_PROJECT_VERSION_MAJOR}.${DLT_PROJECT_VERSION_MINOR}.${DLT_PROJECT_VERSION_PATCH}")
file(WRITE "${CMAKE_BINARY_DIR}/full_version.txt" "${DLT_PROJECT_VERSION_MAJOR}.${DLT_PROJECT_VERSION_MINOR}.${DLT_PROJECT_VERSION_PATCH}-${DLT_VERSION_SUFFIX}")

if("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
    set(LINUX TRUE)
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

set(CMAKE_C_STANDARD 11)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif()

set (CMAKE_AUTOMOC ON)
set (CMAKE_AUTOUIC ON)
set (CMAKE_AUTORCC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

get_target_property(DLT_QT_LIBRARY_PATH ${QT_PREFIX}::Core LOCATION)
get_filename_component(DLT_QT_LIB_DIR ${DLT_QT_LIBRARY_PATH} DIRECTORY)

if(NOT WIN32)
    option(DLT_USE_QT_RPATH "Use RPATH for QT_LIBRARY_PATH to support non-standard QT install locations" ON)
    if (DLT_USE_QT_RPATH)
        # Add Qt to the RPATH, so that there is no need to set LD_LIBRARY_PATH at runtime if Qt is installed in a non-standard location
        set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${DLT_QT_LIB_DIR}")
    endif()
endif()

# Injection of the GCC-specific compilation flags
if(CMAKE_COMPILER_IS_GNUCXX)
    message(STATUS "GCC detected, adding compile flags")
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Wno-variadic-macros -Wno-strict-aliasing -fPIC")
endif()

add_compile_definitions(QT5)
set(QT5_QT6_COMPAT_VERSION "5.14")
# add compiler definition to be used for >= Qt 5.14 code
if(${QT_PREFIX}Core_VERSION VERSION_GREATER_EQUAL ${QT5_QT6_COMPAT_VERSION})
    add_compile_definitions(QT5_QT6_COMPAT)
endif()

option(DLT_USE_STANDARD_INSTALLATION_LOCATION "Use standard GNU installation locations" OFF)
option(DLT_INSTALL_SDK "Install in SDK location" ON)
if(NOT WIN32)
    if(NOT DLT_APP_DIR_NAME)
        set(DLT_APP_DIR_NAME "DLTViewer")
        if(APPLE)
            set(DLT_APP_DIR_NAME "DLTViewer.app")
        endif()
    endif()
    if(DLT_USE_STANDARD_INSTALLATION_LOCATION)
        include(GNUInstallDirs)
        set(DLT_PLUGIN_INSTALLATION_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/dlt-viewer/plugins")
        set(DLT_RESOURCE_INSTALLATION_PATH "${CMAKE_INSTALL_FULL_DATADIR}")
        set(DLT_EXECUTABLE_INSTALLATION_PATH "${CMAKE_INSTALL_FULL_BINDIR}")
        set(DLT_LIBRARY_INSTALLATION_PATH "${CMAKE_INSTALL_FULL_LIBDIR}")
    else()
        if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
            set(CMAKE_INSTALL_PREFIX "DLTViewer")
        endif()
        if(NOT DLT_PLUGIN_INSTALLATION_PATH)
            set(DLT_PLUGIN_INSTALLATION_PATH "${DLT_APP_DIR_NAME}/usr/bin/plugins")
        endif()
        if(NOT DLT_RESOURCE_INSTALLATION_PATH)
            set(DLT_RESOURCE_INSTALLATION_PATH "${DLT_APP_DIR_NAME}/usr/share")
        endif()
        if(NOT DLT_EXECUTABLE_INSTALLATION_PATH)
            set(DLT_EXECUTABLE_INSTALLATION_PATH "${DLT_APP_DIR_NAME}/usr/bin")
        endif()
        if(NOT DLT_LIBRARY_INSTALLATION_PATH)
            set(DLT_LIBRARY_INSTALLATION_PATH "${DLT_APP_DIR_NAME}/usr/lib")
        endif()
    endif()
else()
    if(NOT DLT_APP_DIR_NAME)
        set(DLT_APP_DIR_NAME "./")
    endif()
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        # AppData is a modern install location. No Admin rights required.
        file(TO_CMAKE_PATH "$ENV{LOCALAPPDATA}/Programs/dlt-viewer" CMAKE_INSTALL_PREFIX)
        set(CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX} CACHE PATH "..." FORCE)
    endif()

    if(NOT DLT_PLUGIN_INSTALLATION_PATH)
        set(DLT_PLUGIN_INSTALLATION_PATH "plugins")
    endif()
    if(NOT DLT_RESOURCE_INSTALLATION_PATH)
        set(DLT_RESOURCE_INSTALLATION_PATH ".")
    endif()
    if(NOT DLT_EXECUTABLE_INSTALLATION_PATH)
        set(DLT_EXECUTABLE_INSTALLATION_PATH ".")
    endif()
    if(NOT DLT_LIBRARY_INSTALLATION_PATH)
        set(DLT_LIBRARY_INSTALLATION_PATH ".")
    endif()
endif()

option(DLT_PARSER "Build DLT Parser" OFF)

if(DLT_PARSER)
    add_subdirectory(parser)
endif()

add_subdirectory(qdlt)
add_subdirectory(src)
add_subdirectory(plugin)
add_subdirectory(commander)

message(STATUS "\n\t** DLT Viewer Build Summary **")
message(STATUS "\tCMAKE_INSTALL_PREFIX:         ${CMAKE_INSTALL_PREFIX}")
message(STATUS "\tCMAKE_BUILD_TYPE:             ${CMAKE_BUILD_TYPE}")
message(STATUS "\tCMAKE_SYSTEM_PROCESSOR:       ${CMAKE_SYSTEM_PROCESSOR}")
message(STATUS "\tCMAKE_SYSTEM_NAME:            ${CMAKE_SYSTEM_NAME}")
message(STATUS "\tDLT_QT_LIB_DIR:               ${DLT_QT_LIB_DIR}\n")

# Must be last
include(scripts/windows/package.cmake)
include(scripts/linux/package.cmake)
include(scripts/darwin/package.cmake)

=== commander/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Commander project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author

add_executable(dlt-commander
    main.cpp
    optmanager.cpp
    dltfileexporter.h
    dltfileexporter.cpp)

target_link_libraries(dlt-commander
    qdlt
    ${QT_PREFIX}::Core
    ${QT_PREFIX}::Network
    ${QT_PREFIX}::SerialPort)

if(CMAKE_COMPILER_IS_GNUCXX)
    # https://stackoverflow.com/questions/45329372/ubuntu-recognizes-executable-as-shared-library-and-wont-run-it-by-clicking
    # https://forum.juce.com/t/cmake-executable-build-shows-up-as-shared-library-on-linux-mint/45503/6
    target_link_options(dlt-commander PRIVATE "-no-pie")
endif()

set_target_properties(dlt-commander PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
    INSTALL_RPATH "$ORIGIN/../lib;$<$<BOOL:${DLT_USE_QT_RPATH}>:${DLT_QT_LIB_DIR}>")

    install(TARGETS dlt-commander
    DESTINATION "${DLT_EXECUTABLE_INSTALLATION_PATH}"
    # Underscore for NSIS compatibility https://gitlab.kitware.com/cmake/cmake/-/issues/19982
    COMPONENT dlt_cmd)

if(WIN32)
    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH "${DLT_EXECUTABLE_INSTALLATION_PATH}")
else()
    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH ".")
endif()

include(cmake/${CMAKE_SYSTEM_NAME}.cmake OPTIONAL)

=== qdlt/CMakeLists.txt ===
# SPDX-License-Identifier: MPL-2.0
#
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(qdlt SHARED
    dlt_common.c
    qdltipconnection.cpp
    qdlttcpconnection.cpp
    qdltudpconnection.cpp
    qdltserialconnection.cpp
    qdltmsg.cpp
    qdltfilter.cpp
    qdltfile.cpp
    qdltcontrol.cpp
    qdltconnection.cpp
    qdltbase.cpp
    qdltargument.cpp
    qdltfilterlist.cpp
    qdltfilterindex.cpp
    qdltdefaultfilter.cpp
    qdltmessagedecoder.cpp
    qdltpluginmanager.cpp
    qdltplugin.cpp
    qdltsegmentedmsg.cpp
    qdltoptmanager.cpp
    qdltsettingsmanager.cpp
    qdltexporter.cpp
    qdltimporter.cpp
    fieldnames.cpp
    dltmessagematcher.cpp
    dltmessagematcher.h
    qdltlrucache.hpp
    export_c_rules.h
    export_rules.h
    qdltctrlmsg.cpp
    qdltctrlmsg.h
)

target_compile_definitions(qdlt PRIVATE
    BYTE_ORDER=LITTLE_ENDIAN
    PLUGIN_INSTALLATION_PATH="${DLT_PLUGIN_INSTALLATION_PATH}")

if(WIN32)
    target_compile_definitions(qdlt PRIVATE QDLT_LIBRARY QT_VIEWER)
else()
    target_compile_definitions(qdlt PRIVATE _TTY_POSIX_ QT_VIEWER)
endif()

target_include_directories(qdlt PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../src)

target_link_libraries(qdlt PUBLIC
    ${QT_PREFIX}::Core
    ${QT_PREFIX}::Network
    ${QT_PREFIX}::SerialPort)

if(WIN32)
    target_link_libraries(qdlt PUBLIC ws2_32)
endif()

if(DLT_USE_QT_RPATH)
    set_target_properties(qdlt PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
        INSTALL_RPATH "$ORIGIN;$<$<BOOL:${DLT_USE_QT_RPATH}>:${DLT_QT_LIB_DIR}>")
 endif()

install(TARGETS qdlt
    LIBRARY DESTINATION "${DLT_LIBRARY_INSTALLATION_PATH}"
    RUNTIME DESTINATION "${DLT_LIBRARY_INSTALLATION_PATH}"
    COMPONENT qdlt)

# Install QDLT SDK

if(WIN32)
    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH "${DLT_EXECUTABLE_INSTALLATION_PATH}")
else()
    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH ".")
endif()

if(DLT_INSTALL_SDK)
    install(TARGETS qdlt
        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/sdk/lib"
        COMPONENT qdlt_sdk)
    install(DIRECTORY "."
        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/sdk/include/qdlt"
        COMPONENT qdlt_sdk
        FILES_MATCHING PATTERN "*.h")

foreach(SDK_EXAMPLE IN ITEMS ${SDK_EXAMPLES})
    install(DIRECTORY "../plugin/${SDK_EXAMPLE}"
        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/sdk/src"
        COMPONENT qdlt_sdk)
endforeach()
endif()

install(DIRECTORY "."
    DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/include/qdlt"
    COMPONENT qdlt_sdk
    FILES_MATCHING PATTERN "*.h")

set(SDK_EXAMPLES
    dummycommandplugin
    dummycontrolplugin
    dummydecoderplugin
    dummyviewerplugin)

foreach(SDK_EXAMPLE IN ITEMS ${SDK_EXAMPLES})
    install(DIRECTORY "../plugin/${SDK_EXAMPLE}"
        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/src"
        COMPONENT qdlt_sdk)
endforeach()


find_package(GTest)
# configure unit tests only if gtest found on the system
if (GTest_FOUND)
    message(STATUS "Tests enabled")
    enable_testing()
    add_subdirectory(tests)
endif()

=== src/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author

if("${QT_PREFIX}" STREQUAL "Qt6")
    QT6_ADD_RESOURCES(UI_RESOURCES_RCC resources/resource.qrc)
else()
    QT5_ADD_RESOURCES(UI_RESOURCES_RCC resources/resource.qrc)
endif()

add_executable(dlt-viewer
    main.cpp
    mainwindow.cpp
    project.cpp
    ecudialog.cpp
    applicationdialog.cpp
    contextdialog.cpp
    filterdialog.cpp
    plugindialog.cpp
    settingsdialog.cpp
    injectiondialog.cpp
    searchdialog.cpp
    multiplecontextdialog.cpp
    tablemodel.cpp
    filtertreewidget.cpp
    dltfileutils.cpp
    dltfileindexer.cpp
    dlttableview.cpp
    dltuiutils.cpp
    workingdirectory.cpp
    jumptodialog.cpp
    searchtablemodel.cpp
    pulsebutton.cpp
    plugintreewidget.cpp
    exporterdialog.cpp
    dltmsgqueue.cpp
    dltfileindexerthread.cpp
    dltfileindexerdefaultfilterthread.cpp
    sortfilterproxymodel.cpp
    searchform.h
    searchform.cpp
    ${UI_RESOURCES_RCC}
    resources/dlt_viewer.rc
    ecutree.h
    ecutree.cpp
)

target_link_libraries(dlt-viewer
    qdlt
    ${QT_PREFIX}::Core
    ${QT_PREFIX}::Network
    ${QT_PREFIX}::Widgets
    ${QT_PREFIX}::SerialPort)

if(CMAKE_COMPILER_IS_GNUCXX)
    # https://stackoverflow.com/questions/45329372/ubuntu-recognizes-executable-as-shared-library-and-wont-run-it-by-clicking
    # https://forum.juce.com/t/cmake-executable-build-shows-up-as-shared-library-on-linux-mint/45503/6
    target_link_options(dlt-viewer PRIVATE "-no-pie")
endif()

set_target_properties(dlt-viewer PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
    INSTALL_RPATH "$<$<BOOL:${LINUX}>:$ORIGIN/../lib;>$<$<BOOL:${APPLE}>:@loader_path/../Frameworks;>$<$<BOOL:${DLT_USE_QT_RPATH}>:${DLT_QT_LIB_DIR}>")

    install(TARGETS dlt-viewer
    DESTINATION "${DLT_EXECUTABLE_INSTALLATION_PATH}"
    # Underscore for NSIS compatibility https://gitlab.kitware.com/cmake/cmake/-/issues/19982
    COMPONENT dlt_viewer)

if(WIN32)
    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH "${DLT_EXECUTABLE_INSTALLATION_PATH}")
else()
    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH ".")
endif()

if(DLT_INSTALL_SDK)
    install(FILES
        ../LICENSE.txt
        ../MPL.txt
        ../README.md
        ../ReleaseNotes_Viewer.txt
        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}"
        COMPONENT dlt_viewer)
    install(FILES
        ../doc/dlt_viewer_user_manual.pdf
        ../doc/dlt_viewer_plugins_programming_guide.pdf
        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/doc"
        COMPONENT documentation)
endif()

install(DIRECTORY
    ../filters
    DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}"
    COMPONENT dlt_viewer)
install(DIRECTORY
    ../plugin/examples
    DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/plugins"
    COMPONENT dlt_viewer)

include(cmake/${CMAKE_SYSTEM_NAME}.cmake OPTIONAL)

=== plugin/dltdbusplugin/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
# 
# This file is part of COVESA DLT-Viewer project.
#   
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(dltdbusplugin MODULE dltdbusplugin.cpp
    form.cpp
    dbus.cpp)

target_link_libraries(dltdbusplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(dltdbusplugin)

=== plugin/dummycommandplugin/CMakeLists.txt ===
#
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#
#

add_library(dummycommandplugin MODULE
    dummycommandplugin.cpp)

target_link_libraries(dummycommandplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(dummycommandplugin)

=== plugin/dummycontrolplugin/CMakeLists.txt ===
#
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(dummycontrolplugin MODULE dummycontrolplugin.cpp
   form.cpp)

target_link_libraries(dummycontrolplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(dummycontrolplugin)

=== plugin/dummydecoderplugin/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(dummydecoderplugin MODULE
    dummydecoderplugin.cpp)

target_link_libraries(dummydecoderplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(dummydecoderplugin)

=== qdlt/tests/CMakeLists.txt ===
add_executable(test_dltmessagematcher
    test_dltmessagematcher.cpp
    test_dltctrlmsg.cpp
)
target_link_libraries(
  test_dltmessagematcher
  PRIVATE
    GTest::gtest_main
    qdlt
)

add_test(
  NAME test_dltmessagematcher
  COMMAND $<TARGET_FILE:test_dltmessagematcher>
)


add_executable(test_dltoptmanager
    test_dltoptmanager.cpp
    test_dltctrlmsg.cpp
)

target_link_libraries(
  test_dltoptmanager
  PRIVATE
    GTest::gtest_main
    qdlt
)

add_test(
  NAME test_dltoptmanager
  COMMAND $<TARGET_FILE:test_dltoptmanager>
)

add_executable(test_qdltargument
    test_qdltargument.cpp
)

target_link_libraries(
  test_qdltargument
  PRIVATE
    GTest::gtest_main
    qdlt
)

add_test(
  NAME test_qdltargument
  COMMAND $<TARGET_FILE:test_qdltargument>
)

## dlt-viewer 2.28.1-dfsg

=== debian/changelog ===
dlt-viewer (2.28.1-dfsg-1) unstable; urgency=medium

  * Upload to sid

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 10 Aug 2025 18:10:54 +0200

dlt-viewer (2.28.1-dfsg-1~exp1) experimental; urgency=medium

  * Update copyright years
  * New upstream version 2.28.1-dfsg

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Aug 2025 12:30:48 +0200

=== debian/control ===
Source: dlt-viewer
Section: devel
Priority: optional
Maintainer: Stefan Potyra <stefan@potyra.de>
Uploaders: Bruno "Fuddl" Kleinert <fuddl@debian.org>,
 Aigars Mahinovs <aigarius@debian.org>,
 Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: debhelper-compat (= 13),
 asciidoc,
 dblatex,
 cmake,
 libgtest-dev,
 libxkbcommon-dev,
 qt6-base-dev,
 qt6-declarative-dev,
 qt6-serialport-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/COVESA/dlt-viewer
Vcs-Browser: https://salsa.debian.org/sistpoty/dlt-viewer
Vcs-Git: https://salsa.debian.org/sistpoty/dlt-viewer.git

Package: dlt-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Viewer for COVESA DLT traces
 The Diagnostic Log and Trace Viewer is an application that can send and
 receive control messages to the DLT daemon, e.g., to set individual log
 levels of applications and contexts or get the list of applications
 and contexts registered in the DLT daemon.

Package: dlt-viewer-dev
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Viewer for COVESA DLT traces - development files
 The Diagnostic Log and Trace Viewer is an application that can send and
 receive control messages to the DLT daemon, e.g., to set individual log
 levels of applications and contexts or get the list of applications
 and contexts registered in the DLT daemon.
 .
 This package contains the development files for plugin development.

=== debian/rules ===
#!/usr/bin/make -f

# Ensure texlive respects SOURCE_DATE_EPOCH for reproducible
# timestamps
export FORCE_SOURCE_DATE=1

doc/dlt_viewer_user_manual.pdf: doc/dlt_viewer_user_manual.tex
	cd doc && \
		pdflatex $(^F) && \
		pdflatex $(^F) && \
		cd ..
	$(RM) doc/dlt_viewer_user_manual.aux \
		doc/dlt_viewer_user_manual.log \
		doc/dlt_viewer_user_manual.out \
		doc/dlt_viewer_user_manual.toc

doc/dlt_viewer_plugins_programming_guide.pdf: doc/dlt_viewer_plugins_programming_guide.txt
	cd doc && sh convert.sh && cd ..

%:
	dh $@

#FIXME https://github.com/COVESA/dlt-viewer/issues/707
override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test
	./obj-*/qdlt/tests/test_dltmessagematcher
	./obj-*/qdlt/tests/test_dltoptmanager
	./obj-*/qdlt/tests/test_qdltargument || true
endif

override_dh_auto_configure:
	dh_auto_configure -- \
	      -DDLT_USE_STANDARD_INSTALLATION_LOCATION=ON \
	      -DDLT_USE_QT_RPATH=OFF \
	      -DDLT_PARSER=ON \
	      -DDLT_DUMMY_PLUGINS=ON \
	      -DDLT_INSTALL_SDK=OFF

override_dh_auto_install: doc/dlt_viewer_user_manual.pdf doc/dlt_viewer_plugins_programming_guide.pdf
	dh_auto_install

override_dh_clean:
	$(RM) doc/dlt_viewer_plugins_programming_guide.pdf \
		doc/dlt_viewer_user_manual.pdf \
		debian/doc-stamp
	dh_clean

=== debian/watch ===
version=4
opts=dversionmangle=s/(\+|\.)dfsg$// \
        https://github.com/COVESA/dlt-viewer/tags .*/v?(\d\S*)\.tar\.gz

## dlt-viewer 2.29.0~beta1

=== CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,14 @@
 # implicitly calls version checks
 include(scripts/windows/version.cmake)
 include(scripts/linux/version.cmake)
+
+message(STATUS "COVESA DLT Viewer version: ${DLT_PROJECT_VERSION_MAJOR}.${DLT_PROJECT_VERSION_MINOR}.${DLT_PROJECT_VERSION_PATCH}")
+if(NOT DLT_PROJECT_VERSION_MAJOR OR NOT DLT_PROJECT_VERSION_MINOR OR NOT DLT_PROJECT_VERSION_PATCH)
+    set(DLT_PROJECT_VERSION_MAJOR 0)
+    set(DLT_PROJECT_VERSION_MINOR 0)
+    set(DLT_PROJECT_VERSION_PATCH 0)
+endif()
+message(STATUS "COVESA DLT Viewer version: ${DLT_PROJECT_VERSION_MAJOR}.${DLT_PROJECT_VERSION_MINOR}.${DLT_PROJECT_VERSION_PATCH}")
 
 project(dlt-viewer
     VERSION ${DLT_PROJECT_VERSION_MAJOR}.${DLT_PROJECT_VERSION_MINOR}.${DLT_PROJECT_VERSION_PATCH}

=== qdlt/CMakeLists.txt ===
--- 
+++ 
@@ -89,7 +89,13 @@
 if(WIN32)
     set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH "${DLT_EXECUTABLE_INSTALLATION_PATH}")
 else()
-    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH ".")
+    if(NOT DLT_ADDITIONAL_FILES_INSTALLATION_PATH)
+        # Default to current directory for non-Windows systems
+        # This is where additional files will be installed
+        # e.g., documentation, examples, etc.
+        # It can be overridden by the user via CMake options
+        set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH ".")
+    endif()
 endif()
 
 if(DLT_INSTALL_SDK)

=== plugin/dlttestrobotplugin/CMakeLists.txt ===
#
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(dlttestrobotplugin MODULE dlttestrobotplugin.cpp
   form.cpp)

target_link_libraries(dlttestrobotplugin qdlt ${QT_PREFIX}::Widgets )
add_plugin(dlttestrobotplugin)

=== plugin/filetransferplugin/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
# 
# This file is part of COVESA DLT-Viewer project.
#   
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(filetransferplugin MODULE
    filetransferplugin.cpp
    form.cpp
    file.cpp
    imagepreviewdialog.cpp
    textviewdialog.cpp
    configuration.cpp)

target_link_libraries(filetransferplugin qdlt ${QT_PREFIX}::Widgets ${QT_PREFIX}::PrintSupport )

add_plugin(filetransferplugin)

## dlt-viewer 2.29.0~beta1-dfsg

=== debian/changelog ===
dlt-viewer (2.29.0~beta1-dfsg-1~exp2) experimental; urgency=medium

  * Add upstream-proposed patch to fix versioning during build

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Aug 2025 10:25:46 +0200

dlt-viewer (2.29.0~beta1-dfsg-1~exp1) experimental; urgency=medium

  * New upstream version 2.29.0~beta1-dfsg

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 01 Aug 2025 12:39:41 +0200

## dlt-viewer 2.29.0~beta1.alpha6

=== CMakeLists.txt ===
--- 
+++ 
@@ -135,6 +135,12 @@
     endif()
 endif()
 
+if(OVERWRITE_PLUGIN_INSTALLATION_PATH)
+    set(PLUGIN_INSTALLATION_PATH ${OVERWRITE_PLUGIN_INSTALLATION_PATH})
+else()
+    set(PLUGIN_INSTALLATION_PATH ${DLT_PLUGIN_INSTALLATION_PATH})
+endif()
+
 option(DLT_PARSER "Build DLT Parser" OFF)
 
 if(DLT_PARSER)

=== parser/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_executable(dlt-parser main.cpp
    mainwindow.cpp
    mainwindow.ui
    qdltparser.cpp)

target_link_libraries(dlt-parser ${QT_PREFIX}::Widgets -lstdc++)

set_target_properties(dlt-parser PROPERTIES
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin
    INSTALL_RPATH "$ORIGIN/../lib;$<$<BOOL:${DLT_USE_QT_RPATH}>:${DLT_QT_LIB_DIR}>")

    if(CMAKE_COMPILER_IS_GNUCXX)
    # https://stackoverflow.com/questions/45329372/ubuntu-recognizes-executable-as-shared-library-and-wont-run-it-by-clicking
    # https://forum.juce.com/t/cmake-executable-build-shows-up-as-shared-library-on-linux-mint/45503/6
    target_link_options(dlt-parser PRIVATE "-no-pie")
endif()

install(TARGETS dlt-parser
    DESTINATION "${DLT_EXECUTABLE_INSTALLATION_PATH}"
    # Underscore for NSIS compatibility https://gitlab.kitware.com/cmake/cmake/-/issues/19982
    COMPONENT dlt_parser)


if(DLT_INSTALL_SDK)
    install(FILES
        ../ReleaseNotes_Parser.txt
        DESTINATION "${DLT_EXECUTABLE_INSTALLATION_PATH}"
        COMPONENT dlt_parser)
endif()

=== plugin/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

set (CMAKE_AUTOMOC ON)
set (CMAKE_AUTOUIC ON)

function(add_plugin NAME)
    target_link_libraries(${NAME} qdlt ${QT_PREFIX}::Widgets)

    set_target_properties(${NAME} PROPERTIES
        LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/plugins
        RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin/plugins
        INSTALL_RPATH "$ORIGIN/../../lib;$<$<BOOL:${DLT_USE_QT_RPATH}>:${DLT_QT_LIB_DIR}>")

    install(TARGETS ${NAME}
        DESTINATION "${DLT_PLUGIN_INSTALLATION_PATH}"
        COMPONENT ${NAME})
endfunction()

add_subdirectory(dltdbusplugin)
add_subdirectory(dltlogstorageplugin)
add_subdirectory(dltsystemviewerplugin)
add_subdirectory(dlttestrobotplugin)
add_subdirectory(dltviewerplugin)
add_subdirectory(filetransferplugin)
add_subdirectory(nonverboseplugin)
add_subdirectory(dltsegmentationplugin)

option(DLT_DUMMY_PLUGINS "Build Dummy plugins" OFF)
if(DLT_DUMMY_PLUGINS)
    add_subdirectory(dummycontrolplugin)
    add_subdirectory(dummyviewerplugin)
    add_subdirectory(dummycommandplugin)
    add_subdirectory(dummydecoderplugin)
endif()

=== qdlt/CMakeLists.txt ===
--- 
+++ 
@@ -51,7 +51,7 @@
 
 target_compile_definitions(qdlt PRIVATE
     BYTE_ORDER=LITTLE_ENDIAN
-    PLUGIN_INSTALLATION_PATH="${DLT_PLUGIN_INSTALLATION_PATH}")
+    PLUGIN_INSTALLATION_PATH="${PLUGIN_INSTALLATION_PATH}")
 
 if(WIN32)
     target_compile_definitions(qdlt PRIVATE QDLT_LIBRARY QT_VIEWER)
@@ -105,32 +105,28 @@
     install(DIRECTORY "."
         DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/sdk/include/qdlt"
         COMPONENT qdlt_sdk
-        FILES_MATCHING PATTERN "*.h")
-
-foreach(SDK_EXAMPLE IN ITEMS ${SDK_EXAMPLES})
-    install(DIRECTORY "../plugin/${SDK_EXAMPLE}"
-        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/sdk/src"
-        COMPONENT qdlt_sdk)
-endforeach()
+        FILES_MATCHING PATTERN "*.h"
+        PATTERN "tests" EXCLUDE
+        PATTERN "tests/*" EXCLUDE)
+    set(SDK_EXAMPLES
+        dummycommandplugin
+        dummycontrolplugin
+        dummydecoderplugin
+        dummyviewerplugin
+    )
+    foreach(SDK_EXAMPLE IN ITEMS ${SDK_EXAMPLES})
+        install(DIRECTORY "../plugin/${SDK_EXAMPLE}"
+            DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/sdk/src"
+            COMPONENT qdlt_sdk)
+    endforeach()
 endif()
 
 install(DIRECTORY "."
     DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/include/qdlt"
     COMPONENT qdlt_sdk
-    FILES_MATCHING PATTERN "*.h")
-
-set(SDK_EXAMPLES
-    dummycommandplugin
-    dummycontrolplugin
-    dummydecoderplugin
-    dummyviewerplugin)
-
-foreach(SDK_EXAMPLE IN ITEMS ${SDK_EXAMPLES})
-    install(DIRECTORY "../plugin/${SDK_EXAMPLE}"
-        DESTINATION "${DLT_ADDITIONAL_FILES_INSTALLATION_PATH}/src"
-        COMPONENT qdlt_sdk)
-endforeach()
-
+    FILES_MATCHING PATTERN "*.h"
+    PATTERN "tests" EXCLUDE
+    PATTERN "tests/*" EXCLUDE)
 
 find_package(GTest)
 # configure unit tests only if gtest found on the system

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -80,7 +80,13 @@
 if(WIN32)
     set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH "${DLT_EXECUTABLE_INSTALLATION_PATH}")
 else()
-    set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH ".")
+    if(NOT DLT_ADDITIONAL_FILES_INSTALLATION_PATH)
+        # Default to current directory for non-Windows systems
+        # This is where additional files will be installed
+        # e.g., documentation, examples, etc.
+        # It can be overridden by the user via CMake options
+        set(DLT_ADDITIONAL_FILES_INSTALLATION_PATH ".")
+    endif()
 endif()
 
 if(DLT_INSTALL_SDK)

=== plugin/dltlogstorageplugin/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
# 
# This file is part of COVESA DLT-Viewer project.
#   
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(dltlogstorageplugin MODULE dltlogstorageconfigcreatorplugin.cpp
    logstorageconfigcreatorform.cpp
    logstoragefilter.cpp)

target_link_libraries(dltlogstorageplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(dltlogstorageplugin)

=== plugin/dltsegmentationplugin/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
#
# This file is part of COVESA DLT-Viewer project.
#
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(dltsegmentationplugin MODULE
    dltsegmentationplugin.cpp
    form.cpp)

target_link_libraries(dltsegmentationplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(dltsegmentationplugin)

=== plugin/dummyviewerplugin/CMakeLists.txt ===
# Copyright (C) 2016, Jack S. Smith
# 
# This file is part of COVESA DLT-Viewer project.
#   
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(dummyviewerplugin MODULE
    dummyviewerplugin.cpp
    form.cpp)

target_link_libraries(dummyviewerplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(dummyviewerplugin)

=== plugin/nonverboseplugin/CMakeLists.txt ===
#
# Copyright (C) 2016, Jack S. Smith
# 
# This file is part of COVESA DLT-Viewer project.
#   
# This Source Code Form is subject to the terms of the
# Mozilla Public License (MPL), v. 2.0.
# If a copy of the MPL was not distributed with this file,
# You can obtain one at http://mozilla.org/MPL/2.0/.
#
# For further information see http://www.covesa.global/.
#
# List of changes:
# 01.Oct.2016, Jack Smith <jack.smith@elektrobit.com>, Original Author
#

add_library(nonverboseplugin MODULE
    nonverboseplugin.cpp)

target_link_libraries(nonverboseplugin qdlt ${QT_PREFIX}::Widgets )

add_plugin(nonverboseplugin)

## dlt-viewer 2.29.0~beta1.alpha6-dfsg

=== debian/changelog ===
dlt-viewer (2.29.0~beta1.alpha6-dfsg-2) experimental; urgency=medium

  * Drop R^3: no
  * Fix build by installing some sdk files

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 09 Nov 2025 08:49:16 +0100

dlt-viewer (2.29.0~beta1.alpha6-dfsg-1) experimental; urgency=medium

  * Upload to sid
  * New upstream version 2.29.0~beta1.alpha6-dfsg

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 07 Nov 2025 16:04:07 +0100

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
  qt6-declarative-dev,
  qt6-serialport-dev,
 Standards-Version: 4.7.0
-Rules-Requires-Root: no
 Homepage: https://github.com/COVESA/dlt-viewer
 Vcs-Browser: https://salsa.debian.org/sistpoty/dlt-viewer
 Vcs-Git: https://salsa.debian.org/sistpoty/dlt-viewer.git

=== debian/rules ===
--- 
+++ 
@@ -35,10 +35,13 @@
 	      -DDLT_USE_QT_RPATH=OFF \
 	      -DDLT_PARSER=ON \
 	      -DDLT_DUMMY_PLUGINS=ON \
-	      -DDLT_INSTALL_SDK=OFF
+	      -DDLT_INSTALL_SDK=ON
 
 override_dh_auto_install: doc/dlt_viewer_user_manual.pdf doc/dlt_viewer_plugins_programming_guide.pdf
 	dh_auto_install
+	rm -rf debian/tmp/usr/DLTViewer
+	rm -rf debian/tmp/usr/LICENSE.txt debian/tmp/usr/MPL.txt debian/tmp/usr/README.md debian/tmp/usr/ReleaseNotes_Viewer.txt
+	rm -rf debian/tmp/usr/sdk/include debian/tmp/usr/sdk/lib
 
 override_dh_clean:
 	$(RM) doc/dlt_viewer_plugins_programming_guide.pdf \
